# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .box_auth_mechanism import BoxAuthMechanism

try:
    import pydantic
    if pydantic.__version__.startswith("1."):
        raise ImportError
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class CloudBoxDataSource(pydantic.BaseModel):
    folder_id: typing.Optional[str]
    authentication_mechanism: BoxAuthMechanism = pydantic.Field(
        description="The type of authentication to use (Developer Token or CCG)"
    )
    developer_token: typing.Optional[str]
    client_id: typing.Optional[str]
    client_secret: typing.Optional[str]
    user_id: typing.Optional[str]
    enterprise_id: typing.Optional[str]
    class_name: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
