# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime

try:
    import pydantic
    if pydantic.__version__.startswith("1."):
        raise ImportError
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class CloudJiraDataSource(pydantic.BaseModel):
    """
    Cloud Jira Data Source integrating JiraReader.
    """

    email: typing.Optional[str]
    api_token: typing.Optional[str]
    server_url: typing.Optional[str]
    cloud_id: typing.Optional[str]
    authentication_mechanism: str = pydantic.Field(description="Type of Authentication for connecting to Jira APIs.")
    query: str = pydantic.Field(description="JQL (Jira Query Language) query to search.")
    class_name: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
