# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class VertexEmbeddingMode(str, enum.Enum):
    """
    VertexAI embedding mode.

    Attributes:
    DEFAULT_MODE (str): The default embedding mode, for older models before August 2023,
    that does not support task_type
    CLASSIFICATION_MODE (str): Optimizes embeddings for classification tasks.
    CLUSTERING_MODE (str): Optimizes embeddings for clustering tasks.
    SEMANTIC_SIMILARITY_MODE (str): Optimizes embeddings for tasks that require assessments of semantic similarity.
    RETRIEVAL_MODE (str): Optimizes embeddings for retrieval tasks, including search and document retrieval.
    """

    DEFAULT = "default"
    CLASSIFICATION = "classification"
    CLUSTERING = "clustering"
    SIMILARITY = "similarity"
    RETRIEVAL = "retrieval"

    def visit(
        self,
        default: typing.Callable[[], T_Result],
        classification: typing.Callable[[], T_Result],
        clustering: typing.Callable[[], T_Result],
        similarity: typing.Callable[[], T_Result],
        retrieval: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is VertexEmbeddingMode.DEFAULT:
            return default()
        if self is VertexEmbeddingMode.CLASSIFICATION:
            return classification()
        if self is VertexEmbeddingMode.CLUSTERING:
            return clustering()
        if self is VertexEmbeddingMode.SIMILARITY:
            return similarity()
        if self is VertexEmbeddingMode.RETRIEVAL:
            return retrieval()
